/*
 * FeatureInterface.h
 *
 *  Created on: May 30, 2013
 *      Author: sbak
 */

#ifndef FEATUREINTERFACE_H_
#define FEATUREINTERFACE_H_

#include <vector>
#include <string>
#include "highgui.h"
#include <ltiMatrix.h>

class FeatureInterface {

public:

	virtual int getID() = 0; /* returns ID of a feature */
	virtual std::string getName() = 0;	/* returns a name of a feature */
	virtual std::string getType() = 0; /* returns a type of a feature */
	virtual lti::matrix<float> getValue() = 0;	/* returns a feature vector */
	virtual float getDistance(FeatureInterface* feature) = 0; /* computes distance between features */
	virtual void update(FeatureInterface* feature) = 0; /* updates feature */
	virtual CvRect getGeometry() = 0;	/* returns location of a feature */
	virtual float getWeight() = 0; /* returns weight of a feature */

	virtual void* save() = 0;     /* saves feature */
	virtual void load(void*) = 0; /* loads feature */

};


#endif /* FEATUREINTERFACE_H_ */
