/*
 * CSOperatorInterfaceAbstract.h
 *
 *  Created on: Dec 2, 2010
 *      Author: bboulay
 */

#ifndef CSOPERATORINTERFACEABSTRACT_H_
#define CSOPERATORINTERFACEABSTRACT_H_

#include <string>
#include <vector>
#include <math.h>
#include <map>
#include <tr1/memory>
#include <QObject>

#include "CSAgent.h"

class CSOperatorInterfaceAbstract
{
	public:
		//CSOperatorInterfaceAbstract();
		virtual ~CSOperatorInterfaceAbstract() {};
		virtual std::tr1::shared_ptr<CSBasicType> compute(std::vector<std::tr1::shared_ptr<CSBasicType> >i_predicat) = 0;

	public:
		std::string m_code;
		int m_number_predicat;
		bool m_temporal;
		//the operator name, the name of the agent, the name of the attribute
		static std::map<std::string, std::map<std::string, std::string> > m_operatorAgent;
		//the possibilities //the position, agent name, agent type
		std::vector<std::map<int, std::map<std::string, std::string> > > m_arguments;
		//the possibilities //list of the arguments
		std::vector<std::vector<CSAccessorAgent*> > m_attributes;
};

Q_DECLARE_INTERFACE(CSOperatorInterfaceAbstract, "inria.pulsar.sed.CSOperatorInterfaceAbstract/1.0")

#endif /* CSOPERATORINTERFACEABSTRACT_H_ */
