#ifndef SUPABSTRACTDATA_H
#define SUPABSTRACTDATA_H

#include <dtkCore/dtkAbstractData.h>

#include "supCoreExport.h"

#include "synchronizer.h"

class supAbstractDataPrivate;

// /////////////////////////////////////////////////////////////////
// supAbstractData interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supAbstractData : public dtkAbstractData
{
    Q_OBJECT

public:
             supAbstractData(void);
             supAbstractData(const supAbstractData& other);
    virtual ~supAbstractData(void);

public:
    virtual supAbstractData *clone(void)=0;

public:
    supAbstractData& operator = (const supAbstractData& other);

protected:
    virtual void copy(const dtkAbstractObject& other);

public:
    QString identifier(void) const;

public:
    const QVariantMap& write(void);

    bool setMap(QVariantMap & map);
    QVariantMap  getMap();
    bool read(const QString& file);
    bool write(const QString& file);

public:
    virtual bool setSpecificProperties(const QVariantMap& properties);
    const QVariantMap& getSpecificProperties() const;

    void addSpecificProperty(const QString& key, const QVariant& value);


private:
    DTK_DECLARE_PRIVATE(supAbstractData)
};

#endif

