#ifndef SUPABSTRACTPROCESSACQUISITOR_H
#define SUPABSTRACTPROCESSACQUISITOR_H

#include "supCoreExport.h"
#include "supAbstractProcess.h"

class supAbstractProcessAcquisitionPrivate;

class supAbstractDataStream;
class supDataImage;

// /////////////////////////////////////////////////////////////////
// supAbstractProcessAcquisition interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supAbstractProcessAcquisition : public supAbstractProcess
{
    Q_OBJECT

public:
             supAbstractProcessAcquisition(void);
             supAbstractProcessAcquisition(const supAbstractProcessAcquisition& other);
    virtual ~supAbstractProcessAcquisition(void);

public: // Input
    virtual void setStream( QSharedPointer< supAbstractDataStream >& i_stream );

public: // Process
    virtual bool acquire(void);

public: // Output
    QSharedPointer< supDataImage >& getImage(void);
    QSharedPointer< supDataImage >& getDepth(void);

private:
    DTK_DECLARE_PRIVATE(supAbstractProcessAcquisition)
};

#endif
