#ifndef SUPABSTRACTPROCESSCLASSIFIER_H
#define SUPABSTRACTPROCESSCLASSIFIER_H

#include "supAbstractProcess.h"

#include "supAbstractDataCalibration.h"
#include "supDataBlob.h"
#include "supDataPhysicalObject.h"

#include "supCoreExport.h"

class supAbstractProcessClassifierPrivate;

// /////////////////////////////////////////////////////////////////
// supAbstractProcessClassifier interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supAbstractProcessClassifier : public supAbstractProcess
{
    Q_OBJECT

public:
             supAbstractProcessClassifier(void);
             supAbstractProcessClassifier(const supAbstractProcessClassifier& other);
    virtual ~supAbstractProcessClassifier(void);

public: // Input
    void setCalibration( QSharedPointer< supAbstractDataCalibration >& i_calibration );
    void setBlobs( QList< QSharedPointer< supDataBlob > >& i_blobs );

public: // Process
    virtual bool classify() = 0;

public: // Output
    QList< QSharedPointer< supDataPhysicalObject> >& getPhysicalObjects(void);

private:
    DTK_DECLARE_PRIVATE(supAbstractProcessClassifier);
};

#endif

