#ifndef SUPABSTRACTPROCESSDATAFLOWWRITER_H
#define SUPABSTRACTPROCESSDATAFLOWWRITER_H

#include "supAbstractProcess.h"

#include "supCoreExport.h"

#include "supAbstractData.h"
#include "supDataActor.h"

#include <QFile>
#include <QDomElement>
#include <QDomDocument>

class supAbstractProcessDataFlowWriterPrivate;

// /////////////////////////////////////////////////////////////////
// supAbstractProcessDataFlowWriter interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supAbstractProcessDataFlowWriter : public supAbstractProcess
{
    Q_OBJECT

public:
             supAbstractProcessDataFlowWriter(void);
             supAbstractProcessDataFlowWriter(const supAbstractProcessDataFlowWriter& other);
    virtual ~supAbstractProcessDataFlowWriter(void);

             void setFilePath (const QFile& file);
             const QFile& getFilePath();

             virtual void setDataFlow (const QList< QSharedPointer< supAbstractData > >& dataFlow);
             virtual void setDataFlow (const QSharedPointer< supAbstractData >& dataFlow);

             virtual bool writeDataFlow();

private:
             void xmlGen();
             QDomElement setTimeStampElement();

private:
    DTK_DECLARE_PRIVATE(supAbstractProcessDataFlowWriter);
};

#endif

