#ifndef SUPABSTRACTPROCESSREACQUISITION_P_H
#define SUPABSTRACTPROCESSREACQUISITION_P_H
 
#include "supAbstractProcess_p.h"

#include "supDataActor.h"
#include "supDataImage.h"
 
class supAbstractProcessReAcquisition;
 
////////////////////////////////////////////////////
// supAbstractProcessReAcquisitionPrivate interface
////////////////////////////////////////////////////
 
class DTKCORE_EXPORT supAbstractProcessReAcquisitionPrivate : public supAbstractProcessPrivate
{
public:
    supAbstractProcessReAcquisitionPrivate(supAbstractProcessReAcquisition *q = 0) : supAbstractProcessPrivate(q) {}
    supAbstractProcessReAcquisitionPrivate(const supAbstractProcessReAcquisitionPrivate& other) : supAbstractProcessPrivate(other), image(other.image), i_actors(other.i_actors) {}
 
public:
    virtual ~supAbstractProcessReAcquisitionPrivate(void) {}

public: // Input
    QSharedPointer< supDataImage > image;
    QList< QSharedPointer< supDataActor > > i_actors;

public: // Output
    QList< QSharedPointer< supDataActor > > o_actors;
};
 
////////////////////////////////////////////////////
// supAbstractProcessReAcquisition protected constructors
////////////////////////////////////////////////////
 
DTK_IMPLEMENT_PRIVATE(supAbstractProcessReAcquisition, supAbstractProcess);
 
#endif
