#ifndef SUPABSTRACTPROCESSXMLReader_P_H
#define SUPABSTRACTPROCESSXMLReader_P_H

#include "supAbstractProcess_p.h"

#include "supDataPhysicalObject.h"
#include "supDataActor.h"


class supAbstractProcessXMLReaderWriter;

////////////////////////////////////////////////////
// supAbstractProcessXMLReaderWriterPrivate interface
////////////////////////////////////////////////////

class DTKCORE_EXPORT supAbstractProcessXMLReaderWriterPrivate : public supAbstractProcessPrivate
{
public:
    supAbstractProcessXMLReaderWriterPrivate(supAbstractProcessXMLReaderWriter *q = 0) : supAbstractProcessPrivate(q) {}
    supAbstractProcessXMLReaderWriterPrivate(const supAbstractProcessXMLReaderWriterPrivate& other) : supAbstractProcessPrivate(other), i_pathToXML(other.i_pathToXML) {}

public:
    virtual ~supAbstractProcessXMLReaderWriterPrivate(void) {}

public: // Input
    std::string i_pathToXML;

public: // Output
    QList< QSharedPointer< supDataPhysicalObject > > o_PhysicalObjectList;
    QList< QSharedPointer< supDataActor > > o_ActorList;
};

////////////////////////////////////////////////////
// supAbstractProcessXMLReaderWriter protected constructors
////////////////////////////////////////////////////

DTK_IMPLEMENT_PRIVATE(supAbstractProcessXMLReaderWriter, supAbstractProcess);

#endif
