/* supDataActor_p.h ---
 *
 * Author: %Author%
 */

/* Commentary: 
 * 
 */

/* Change log:
 * 
 */

#ifndef SUPDATAACTOR_P_H
#define SUPDATAACTOR_P_H

#include "supCoreExport.h"
#include "supAbstractData_p.h"

#include "skeletonStructure.h"


class supDataActor;

////////////////////////////////////////////////////
// supDataActorPrivate interface
////////////////////////////////////////////////////

class DTKCORE_EXPORT supDataActorPrivate : public supAbstractDataPrivate
{
public:
    supDataActorPrivate(supDataActor *q = 0) : supAbstractDataPrivate(q), _skeleton(), _pixels(), _voxels() {
        _id = -1;
        _position.x = _position.y = _position.z = 0;
        _bbox2d.x = _bbox2d.y = -1;
        _bbox2d.width = _bbox2d.height = 0;
    }
    supDataActorPrivate(const supDataActorPrivate& other) : supAbstractDataPrivate(other), _id(other._id), _type( other._type ), _bbox3d (other._bbox3d ), _bbox2d( other._bbox2d ), _position( other._position ), _trajectory3d( other._trajectory3d ), _skeleton(other._skeleton), _pixels( other._pixels ),  _voxels( other._voxels ) {}

public:
    virtual ~supDataActorPrivate(void) {}

public:
    // private members of the class are put here in the d-pointer, eg
    // int index;
    unsigned int _id;
    std::string _type;
    BoundingBox3D _bbox3d;
    cv::Rect _bbox2d;
    cv::Point3f _position;
    CTrajectory3D _trajectory3d;
    SkeletonStructure _skeleton;
    std::list < cv::Point2i > _pixels;
	std::list < cv::Point3f > _voxels;
    sup::SpLinkedPhysicalObjectInterface _spLPO;
    SpLinkedPhysicalObjectList _spLPOList;
    double _speed;
};

////////////////////////////////////////////////////
// supDataActor protected constructors
////////////////////////////////////////////////////

DTK_IMPLEMENT_PRIVATE(supDataActor, supAbstractData);

#endif
