#ifndef SUPDATAEVENT_H
#define SUPDATAEVENT_H

#include "supAbstractData.h"
#include "synchronizer.h"
#include "supCoreExport.h"

class supDataEventPrivate;

// /////////////////////////////////////////////////////////////////
// supDataEvent interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supDataEvent : public supAbstractData
{
    Q_OBJECT

public:
             supDataEvent(void);
             supDataEvent(const supDataEvent& other);
    virtual ~supDataEvent(void);

public:
    supDataEvent *clone(void);
    supDataEvent& operator = (const supDataEvent& other);
    QString identifier(void) const;

protected:
   virtual void copy(const dtkAbstractObject& other);

public:
   void 	setSEDAlarmLevel    (std::string i_alarm_level);
   void 	setSEDBegin         (const CSynchronizer& i_begin);
   void 	setSEDEnd           (const CSynchronizer& i_end);
   void 	setSEDDuration      (double m_sec);
   void     setSEDLatency       (double m_lat);
   void 	setSEDId            (unsigned int i_id);
   void 	setSEDName          (std::string i_name);
   void 	setSEDType          (std::string i_type);
   void     setSEDConfidence    (double);

   //   void    setText             (QString i_newText);
   //   void    setType             (QString i_newType);
   //   void	setEventId          ( unsigned int i_eventId );
      void    setInvolvedActorId  ( unsigned int i_involvedActorId );
//      void    setInvolvedContext  ( QString i_involvedContext );
   //   void    setLikelyHood       ( double i_newLikelyHood );
   //   void    setPos3D            ( sup::CFloat3D i_newPos3D )   ;
   //   void    setPos2D            ( sup::CFloat2D i_newPos2D )   	;
   //   void 	setSEDAgent         (std::map<std::string, std::vector<int> > i_agent);

public:
    std::string             getSEDAlarmLevel()  const;
    double                  getSEDConfidence()  const;
    double                  getSEDDuration()    const;
    double                  getSEDLatency()     const;

    const   CSynchronizer&  getSEDBegin()       const;
    const   CSynchronizer&  getSEDEnd()         const;

    unsigned int            getSEDId()          const;
    std::string             getSEDName()        const;
    std::string             getSEDType()        const;
    unsigned int  	getInvolvedActorId() const;

    //      unsigned int  	getEventId();

    //      QString       	getInvolvedContext();
    //      double        	getLikelyHood();
    //      QString         getText();
    //      QString       	getType();
    //      std::map<std::string, std::vector<int> > getSEDAgents();
    //      sup::CFloat3D 	getPos3D();
    //      sup::CFloat2D 	getPos2D();

private:
    DTK_DECLARE_PRIVATE(supDataEvent);
};

Q_DECLARE_METATYPE(supDataEvent)  // If your class is pure virtual, you cannot register to QMetatype.
Q_DECLARE_METATYPE(supDataEvent*) // Hence, you need to comment theses lines.

#endif

