#ifndef SUPDATAEVENT_P_H
#define SUPDATAEVENT_P_H

#include "supCoreExport.h"

#include "supAbstractData_p.h"

class supDataEvent;

////////////////////////////////////////////////////
// supDataEventPrivate interface
////////////////////////////////////////////////////

class DTKCORE_EXPORT supDataEventPrivate : public supAbstractDataPrivate
{
public:
    supDataEventPrivate(supDataEvent *q = 0) : supAbstractDataPrivate(q), m_SED_confidence(0), m_SED_duration(0), m_SED_Id(0), m_SED_latency(0) {}
    supDataEventPrivate(const supDataEventPrivate& other) : supAbstractDataPrivate(other),
        m_SED_Alarm_level   (other.m_SED_Alarm_level),
        m_SED_begin         (other.m_SED_begin),
        m_SED_confidence    (other.m_SED_confidence),
        m_SED_duration      (other.m_SED_duration),
        m_SED_end           (other.m_SED_end),
        m_SED_Id            (other.m_SED_Id),
        m_SED_latency       (other.m_SED_latency),
        m_SED_name          (other.m_SED_name),
        m_SED_type          (other.m_SED_type),
        m_involvedActorId   (other.m_involvedActorId){}


public:
    virtual ~supDataEventPrivate(void) {}

public:
    // private members of the class are put here in the d-pointer, eg
    // int index;

    std::string     m_SED_Alarm_level;
    CSynchronizer   m_SED_begin;
    double          m_SED_confidence;
    double          m_SED_duration; //seconds
    CSynchronizer   m_SED_end;
    unsigned int    m_SED_Id;
    double          m_SED_latency; //seconds
    std::string     m_SED_name;
    std::string     m_SED_type;
    unsigned int    m_involvedActorId;

    // Previous attributes of CEvent.h (class of previous sup platform)
    //    std::map<std::string, std::map<std::string, std::string> > m_SED_Miscellaneous;
    //    unsigned int    m_eventId;

    //    std::string     m_involvedContext;
    //    std::string     m_message;
    //	sup::CFloat2D   m_pos2d;
    //	sup::CFloat3D   m_pos3d;
    //    std::string     m_type;
    //    double          m_likelyHood;

    //	std::map<std::string, std::vector<int> > m_SED_agents;

    //use for manging or special treatments associated to the event model
	//not yet use in sup


    //what is the difference between m_SED_ID and m_eventID???
};

////////////////////////////////////////////////////
// supDataEvent protected constructors
////////////////////////////////////////////////////

DTK_IMPLEMENT_PRIVATE(supDataEvent, supAbstractData);

#endif
