/* supDataLinkedPhysicalObject.h ---
 *
 * Author: %Author%
 */

/* Commentary:
 *
 */

/* Change log:
 *
 */

#ifndef SUPDATALINKEDPHYSICALOBJECT_H
#define SUPDATALINKEDPHYSICALOBJECT_H

#include "supAbstractData.h"
#include "supCoreExport.h"
#include <tr1/memory>

#include "supDataPhysicalObject.h"
#include "supDataLinkedPhysicalObjectLink.h"
//#include "wrapper/PhysicalObjectInterface.h"


class supDataLinkedPhysicalObjectPrivate;

// /////////////////////////////////////////////////////////////////
// supDataLinkedPhysicalObject interface
// /////////////////////////////////////////////////////////////////

class supDataLinkedPhysicalObject;

//typedef QSharedPointer<supAbstractDataLinkedPhysicalObject > SpLinkedPhysicalObjectInterface;

typedef std::list< SpLinkedPhysicalObject > SpLinkedPhysicalObjectList;

// todo remove the following definition 
namespace sup{
       typedef SpLinkedPhysicalObjectList SpLinkedPhysicalObjectInterfaceList;
}

class SUPCORE_EXPORT supDataLinkedPhysicalObject : public supAbstractData
{
    Q_OBJECT

public:
             supDataLinkedPhysicalObject(void);
             supDataLinkedPhysicalObject(const supDataLinkedPhysicalObject& other);
    virtual ~supDataLinkedPhysicalObject(void);

/*** Begin Data Only */
public:
    virtual supDataLinkedPhysicalObject *clone(void);

public:
    supDataLinkedPhysicalObject& operator = (const supDataLinkedPhysicalObject& other);

protected:
    virtual void copy(const dtkAbstractObject& other);

public:
    QString identifier(void) const;
/* End Data Only ***/


    void setPhysicalObject(const SpPhysicalObject &i_PO) { this->PO = i_PO; } ;
    SpPhysicalObject getPhysicalObject() const{ return PO; } ;


	unsigned int getId() const { return id;} ;
	void setId(unsigned int i_id) { id = i_id;};


	SpLinkedPhysicalObjectList getFathers() const;
	SpLinkedPhysicalObjectLink addFather( SpLinkedPhysicalObject );

	void addFatherLink( SpLinkedPhysicalObjectLink );
	void removeFatherLink( SpLinkedPhysicalObjectLink );
	SpLinkedPhysicalObjectLinkList getFatherLinks() const;

	SpLinkedPhysicalObjectList getSons() const;
	SpLinkedPhysicalObjectLink addSon ( SpLinkedPhysicalObject );

	void addSonLink( sup::SpLinkedPhysicalObjectInterfaceLink );
	void removeSonLink( sup::SpLinkedPhysicalObjectInterfaceLink );
	SpLinkedPhysicalObjectLinkList getSonLinks() const;
	
	void releaseLPO();


	
private:
    DTK_DECLARE_PRIVATE(supDataLinkedPhysicalObject);

    SpPhysicalObject PO;
	unsigned int id;
	
       SpLinkedPhysicalObjectList fathers;
       SpLinkedPhysicalObjectList sons;
       SpLinkedPhysicalObjectLinkList fatherLinks;
       SpLinkedPhysicalObjectLinkList sonLinks;

};

Q_DECLARE_METATYPE(supDataLinkedPhysicalObject)  // If your class is pure virtual, you cannot register to QMetatype.
Q_DECLARE_METATYPE(supDataLinkedPhysicalObject*) // Hence, you need to comment theses lines.
Q_DECLARE_METATYPE(QSharedPointer <supDataLinkedPhysicalObject>)


//typedef QSharedPointer <supDataLinkedPhysicalObject> SpLinkedPhysicalObject;
// todo use qshared pointer as above
//typedef std::tr1::shared_ptr <supDataLinkedPhysicalObject> SpLinkedPhysicalObject;
//typedef std::list < SpLinkedPhysicalObject > SpLinkedPhysicalObjectList;

//typedef SpLinkedPhysicalObject SpLinkedPhysicalObjectInterface;
//typedef SpLinkedPhysicalObjectList SpLinkedPhysicalObjectInterfaceList;





#endif

