/* supDataLinkedPhysicalObjectLink.h ---
 *
 * Author: %Author%
 */

/* Commentary:
 *
 */

/* Change log:
 *
 */

#ifndef SUPDATALINKEDPHYSICALOBJECTLINK_H
#define SUPDATALINKEDPHYSICALOBJECTLINK_H

#include <dtkCore/dtkAbstractData.h>

#include "supCoreExport.h"

// todo qshared pointer or sp
class supDataLinkedPhysicalObject;
typedef QSharedPointer<supDataLinkedPhysicalObject > SpLinkedPhysicalObject;

// todo remove the following definition 
namespace sup{
       typedef SpLinkedPhysicalObject SpLinkedPhysicalObjectInterface;
}



class supDataLinkedPhysicalObjectLinkPrivate;

// /////////////////////////////////////////////////////////////////
// supDataLinkedPhysicalObjectLink interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supDataLinkedPhysicalObjectLink : public dtkAbstractData
{
    Q_OBJECT

public:
             supDataLinkedPhysicalObjectLink(void);
             supDataLinkedPhysicalObjectLink(const supDataLinkedPhysicalObjectLink& other);
             supDataLinkedPhysicalObjectLink( const SpLinkedPhysicalObject i_father,
            		 	 	 	 	 	 	  const SpLinkedPhysicalObject i_son, double i_reliability = 1 );
    virtual ~supDataLinkedPhysicalObjectLink(void);

/*** Begin Data Only */
public:
    virtual supDataLinkedPhysicalObjectLink *clone(void);

public:
    supDataLinkedPhysicalObjectLink& operator = (const supDataLinkedPhysicalObjectLink& other);

protected:
    virtual void copy(const dtkAbstractObject& other);

public:
    QString identifier(void) const;
/* End Data Only ***/

	SpLinkedPhysicalObject getFather() const;
	void setFather( SpLinkedPhysicalObject i_father );
	SpLinkedPhysicalObject getSon() const;
	void setSon( SpLinkedPhysicalObject i_son );
	void setReliability( double i_newReliability );
	double getReliability() const;

private:
    DTK_DECLARE_PRIVATE(supDataLinkedPhysicalObjectLink);

    double reliability;
    SpLinkedPhysicalObject father;
    SpLinkedPhysicalObject son;

};


Q_DECLARE_METATYPE(supDataLinkedPhysicalObjectLink)  // If your class is pure virtual, you cannot register to QMetatype.
Q_DECLARE_METATYPE(supDataLinkedPhysicalObjectLink*) // Hence, you need to comment theses lines.
Q_DECLARE_METATYPE(QSharedPointer <supDataLinkedPhysicalObjectLink>)

typedef supDataLinkedPhysicalObjectLink supDataLinkedPhysicalObjectInterfaceLink;

typedef QSharedPointer< supDataLinkedPhysicalObjectLink > SpLinkedPhysicalObjectLink;
typedef std::list< SpLinkedPhysicalObjectLink > SpLinkedPhysicalObjectLinkList;


namespace  sup{
   	typedef SpLinkedPhysicalObjectLink SpLinkedPhysicalObjectInterfaceLink;
   	typedef SpLinkedPhysicalObjectLinkList SpLinkedPhysicalObjectInterfaceLinkList;
}

#endif

