/* supDataPhysicalObject_p.h ---
 *
 * Author: %Author%
 */

/* Commentary: 
 * 
 */

/* Change log:
 * 
 */

#ifndef SUPDATAPHYSICALOBJ_P_H
#define SUPDATAPHYSICALOBJ_P_H

#include "supCoreExport.h"

//#include <dtkCore/dtkAbstractData_p.h>
#include "supAbstractData_p.h"

#include "skeletonStructure.h"

class supDataPhysicalObject;

////////////////////////////////////////////////////
// supDataPhysicalObjectPrivate interface
////////////////////////////////////////////////////

class DTKCORE_EXPORT supDataPhysicalObjectPrivate : public supAbstractDataPrivate
{
public:
    supDataPhysicalObjectPrivate(supDataPhysicalObject *q = 0) : supAbstractDataPrivate(q), _skeleton(), _pixels() {
        _id = -1;
        _position.x = _position.y = _position.z = 0;
        _bbox2d.x = _bbox2d.y = -1;
        _bbox2d.width = _bbox2d.height = 0;
    }
    supDataPhysicalObjectPrivate(const supDataPhysicalObjectPrivate& other) : supAbstractDataPrivate(other), _id(other._id), _position( other._position ), _centroidPosition( other._centroidPosition), _highestPosition( other._highestPosition ), _lowestPosition( other._lowestPosition), _bbox2d( other._bbox2d), _bbox3d( other._bbox3d ), _type( other._type ), _skeleton( other._skeleton), _pixels(other._pixels), _voxels(other._voxels) {}

public:
    virtual ~supDataPhysicalObjectPrivate(void) {}

public:
    // private members of the class are put here in the d-pointer, eg
    // int index;
    int _id;
    cv::Point3f _position, _centroidPosition, _highestPosition, _lowestPosition;
    cv::Rect _bbox2d;
    BoundingBox3D _bbox3d;
    std::string _type;
    SkeletonStructure _skeleton;
    std::list < cv::Point2i > _pixels;
    std::list < cv::Point3f > _voxels;
};

////////////////////////////////////////////////////
// supDataPhysicalObject protected constructors
////////////////////////////////////////////////////

DTK_IMPLEMENT_PRIVATE(supDataPhysicalObject, supAbstractData);


#endif
