#ifndef SUPVIEW_H
#define SUPVIEW_H

#include "supCoreExport.h"

#include <dtkCore/dtkAbstractView.h>

#include <supCore/supDataImage.h>
#include <supCore/supDataBlob.h>
#include <supCore/supDataPhysicalObject.h>


class supViewPrivate;

class SUPCORE_EXPORT supView : public dtkAbstractView
{
    Q_OBJECT

public:
             supView(void);
             supView(const supView& other);
    virtual ~supView(void);

public:
    void setAcquisitionImage( QSharedPointer< supDataImage >  i_acquisition_image );
    void setSegmentationImage( QSharedPointer< supDataImage >  i_segmentation_image );
    void setBlobs( QList< QSharedPointer< supDataBlob > > i_blobs );
    void setPhysicalObjects( QList< QSharedPointer< supDataPhysicalObject > > i_pos );

public:
    void updateDisplay(void);
    QSharedPointer< supDataImage >& getDisplay(void);

public:
    QWidget* widget(void);

private:
    DTK_DECLARE_PRIVATE(supView)
};

// /////////////////////////////////////////////////////////////////
// 
// /////////////////////////////////////////////////////////////////

SUPCORE_EXPORT dtkAbstractView *createSupView(void);

#endif
